import "source-map-support/register";
import { PvjsonEntity, GPMLElement, Pathway, PathwayStarter, PvjsonEntityMap } from "./gpml2pvjson";
import { GraphIdManager } from "./GraphIdManager";
export declare type GPML_VALUE_SIMPLE = string | number;
export declare type GPML_VALUE_UP_TO_OBJECT = GPML_VALUE_SIMPLE | Record<string, GPML_VALUE_SIMPLE>;
export declare type GPML_VALUE_UP_TO_SUB_OBJECT = GPML_VALUE_UP_TO_OBJECT | Record<string, GPML_VALUE_UP_TO_OBJECT>;
export declare type GPML_VALUE = GPML_VALUE_UP_TO_SUB_OBJECT | GPML_VALUE_UP_TO_SUB_OBJECT[];
export declare class Processor {
    output: {
        pathway: Pathway | PathwayStarter;
        entityMap: PvjsonEntityMap;
    };
    graphIdManager: GraphIdManager;
    graphIdsByGraphRef: Record<string, string[]>;
    containedGraphIdsByGroupGraphId: Record<string, string[]>;
    containedGraphIdsByGroupGroupId: Record<string, string[]>;
    promisedGraphIdByGroupId: Record<string, Promise<string>>;
    groupIdToGraphIdStream: Highland.Stream<[string, string]>;
    promisedGPMLElementByGraphId: Record<string, Promise<GPMLElement>>;
    gpmlElementStream: Highland.Stream<GPMLElement>;
    promisedPvjsonEntityLatestByGraphId: Record<string, Promise<PvjsonEntity>>;
    pvjsonEntityLatestStream: Highland.Stream<PvjsonEntity>;
    graphIdToZIndex: Record<string, number>;
    KeyMappings: Record<string, any>;
    KeyValueConverters: Record<string, any>;
    ValueMappings: Record<string, any>;
    ValueConverters: Record<string, any>;
    constructor(KeyMappings: any, KeyValueConverters: any, ValueMappings: any, ValueConverters: any);
    private ensureGraphIdExists;
    fillInGPMLPropertiesFromParent: any;
    getPvjsonEntityLatestByGraphId: (graphId: any) => Promise<PvjsonEntity>;
    getGPMLElementByGraphId: (GraphId: any) => Promise<Record<string, any>>;
    preprocessGPMLElement: (gpmlElement: Record<string, any>) => Record<string, any>;
    processGPMLAndPropertiesAndType: any;
    processProperties: any;
    processPropertiesAndType: any;
    private processType;
    setPvjsonEntity: (pvjsonEntity: any) => void;
    getGPMLKeyAsJSFunctionName: (gpmlKey: string) => string;
    getPvjsonValue: (gpmlElement: any, gpmlKey: string, gpmlValue: GPML_VALUE) => any;
    processKV: any;
}
