import { SmartPoint } from "../geom-utils";
import { PvjsonEdge, AttachablePoint, Orientation } from "../gpml2pvjson";
/**
 * getOrientationOfHyperedgeStartPoint
 *
 * Get orientation of the start point of an edge that is attached to another
 * edge.
 *
 * @param referencedEdge {PvjsonEdge}
 * @param startPoint {Point}
 * @param otherPoint {Point}
 * @return {Orientation}
 */
export declare function getOrientationOfHyperedgeStartPoint(referencedEdge: PvjsonEdge, startPoint: AttachablePoint & SmartPoint, endPoint: AttachablePoint & SmartPoint): Orientation;
export declare const getOrientationOfHyperedgeEndPoint: any;
export declare function validateOrientation(orientation: Orientation): boolean;
